﻿Imports System.Data.Entity
Imports Escola_Macoratti.Macoratti.Models
Imports System.Data.Entity.Infrastructure

Public Class Alunos
    Inherits System.Web.UI.Page

    Public Function alunosGrid_GetDados() As IQueryable(Of Aluno)
        Dim db As New EscolaContext()
        Dim consulta = db.Alunos.Include(Function(s) s.Matriculas.Select(Function(e) e.Curso))
        Return consulta
    End Function

    '' The id parameter name should match the DataKeyNames value set on the control
    'Public Sub alunosGrid_UpdateItem(ByVal id As Integer)
    '    Dim item As Escola_Macoratti.Macoratti.Models.Aluno = Nothing
    '    ' Load the item here, e.g. item = MyDataLayer.Find(id)
    '    If item Is Nothing Then
    '        ' The item wasn't found
    '        ModelState.AddModelError("", String.Format("Item with id {0} was not found", id))
    '        Return
    '    End If
    '    TryUpdateModel(item)
    '    If ModelState.IsValid Then
    '        ' Save changes here, e.g. MyDataLayer.SaveChanges()

    '    End If
    'End Sub
    Public Sub alunosGrid_UpdateItem(ByVal _alunoID As Integer)
        Using db As EscolaContext = New EscolaContext()
            Dim item As Aluno = Nothing
            item = db.Alunos.Find(_alunoID)
            If item Is Nothing Then
                ModelState.AddModelError("", String.Format("Item com o id {0} não foi localizado", _alunoID))
                Return
            End If
            TryUpdateModel(item)
            If ModelState.IsValid Then
                db.SaveChanges()
            End If
        End Using
    End Sub
    Public Sub alunosGrid_DeleteItem(ByVal _alunoID As Integer)
        Using db As EscolaContext = New EscolaContext()
            Dim item As Aluno = New Aluno() With {.AlunoID = _alunoID}
            db.Entry(item).State = System.Data.EntityState.Deleted
            Try
                db.SaveChanges()
            Catch ex As DbUpdateConcurrencyException
                ModelState.AddModelError("", String.Format("Item com id {0} não existe mais no banco de dados.", _alunoID))
            End Try
        End Using
    End Sub

End Class